Page MenuHomePhabricator

Newcomer tasks search error card has UX issues
Open, Needs TriagePublicBUG REPORT

Description

There are some small issues with the search error card shown on the homepage in the suggested edits module when searching fails (this doesn't normally happen but the search engine can e.g. get overloaded temporarily):

  • The current wording is very similar to that of the no results card (shown when the search worked but there aren't any tasks available) and doesn't make it clear to the user that this is a temporary issue.
  • It would be nice to have a refresh/reload link (e.g. like this: F34574075)
  • It seems like opening and closing (without changing anything) the topic filter turns the error card into a no results card (see video from 0:48: F34574312). In general, opening and closing a filter dialog with no changes probably shouldn't even trigger a search.
  • In the same video, the text of the topic filter does not update correctly, so there is probably some unhandled JS error happening somewhere.
  • Besides the card, task search is also used for displaying a count in the footer of the topic filter and task type filter dialogs (and the similar onboarding dialogs), but we don't have any error handling there. We could display a message in the footer on error, like in F34574077.

Event Timeline

@Etonkovidova -- could you please investigate this?

I checked Special:NewcomerTasksInfo - the number of tasks is sufficient.

From the recording it seems that it takes longer to fetch the results, so I checked logstash - there were 274 warnings "Search error: Search is currently too busy. Please try again later." (the first timestamp - Aug 1, 2021 @ 16:33:50.063) coming from Homepage. For enwiki the last timestamps is Aug 2, 2021 @ 13:41:05.70 and it seems to start on Aug 1, 2021 @ 15:18:08.694.

Error
normalized_message
Search error: {message}

I tried to reproduce the issue with network throttling - no success so far.

I checked logstash - there were 274 warnings "Search error: Search is currently too busy. Please try again later." coming from Homepage

It seems like an unfortunate implementation that that's handled with a warning + an empty search result instead of an error. We should probably special-case it and treat it as an error on our side.

MMiller_WMF added a subscriber: MPhamWMF.

@MPhamWMF -- FYI that we encountered this issue with Search that impacted our users. I'm not sure if this is actionable or interesting to you, but let me know if we should do anything or if we can help.

@RHo -- I'm adding this to your column so you can jot down what you think is the right way for us to handle this error/warning in the future for our users.

It seems like an unfortunate implementation that that's handled with a warning + an empty search result instead of an error. We should probably special-case it and treat it as an error on our side.

Actually it does get handled as an error, both in the search API and our code. Our error page is just confusingly similarly worded to the no results page, but it's the error page that's shown in the video.

That leaves three issues, I think:

  • maybe the wording of the error page should be improved to make it clearer that this is a temporary error (it does say that now, but I'm not sure that's how most users would interpret it)
  • there is a point in the video where Marshall gets the error page, opens the topic filter, closes the topic filter with no changes, and is now seeing a no results page. That seems like a bug.
  • how to handle errors in search requests used for updating the footer count in the filter dialog (and the onboarding dialog I guess)? Currently it just keeps pulsing forever. Maybe an error icon would be better, although there's not much space for explaining to the user what's going on.

It seems like an unfortunate implementation that that's handled with a warning + an empty search result instead of an error. We should probably special-case it and treat it as an error on our side.

Actually it does get handled as an error, both in the search API and our code. Our error page is just confusingly similarly worded to the no results page, but it's the error page that's shown in the video.

That leaves three issues, I think:

  • maybe the wording of the error page should be improved to make it clearer that this is a temporary error (it does say that now, but I'm not sure that's how most users would interpret it)

Agree it could be a simple wording change makes sense. However, is it the case that the user would have to refresh in order for the article suggestions to appear even after the error is fixed, or will it happen automatically? If the former, then maybe we could also add a refresh action to the message, maybe something like this:

image.png (902×704 px, 51 KB)

  • there is a point in the video where Marshall gets the error page, opens the topic filter, closes the topic filter with no changes, and is now seeing a no results page. That seems like a bug.

Agree with @Tgr this is a bug or two, since @MMiller_WMF it looks like you have topic filters applied already when no results are found and it's only when you open the topic filter to select other interests that the suggestions appear.

image.png (956×1 px, 108 KB)

So the two unexpected bugs are:

  1. when users have topics selected this should be reflected in the UI with "X topics selected", and
  2. the specific illustration and message should prompt the user to change their filters. I.e., it should look like the following:

image.png (978×702 px, 55 KB)

  • how to handle errors in search requests used for updating the footer count in the filter dialog (and the onboarding dialog I guess)? Currently it just keeps pulsing forever. Maybe an error icon would be better, although there's not much space for explaining to the user what's going on.

Perhaps we could just not show the icon at all and try to use same/similar temporary error message No suggested articles available right now

image.png (214×622 px, 15 KB)

Replaced the animated gif with a video so it's a little easier to navigate.

However, is it the case that the user would have to refresh in order for the article suggestions to appear even after the error is fixed, or will it happen automatically? If the former, then maybe we could also add a refresh action to the message, maybe something like this: F34574075

They would have to refresh, or do something equivalent like changing filter settings.

  1. when users have topics selected this should be reflected in the UI with "X topics selected", and

True, that was also broken. Maybe something related to the search errors caused a JS error? Otherwise, I don't see a connection.

  1. the specific illustration and message should prompt the user to change their filters. I.e., it should look like the following:

F34574071

We don't have that kind of message currently, so that would be a feature request. The other bug is around 0:48 in the video: opening and closing (with no action) the topic filter replaces the error page with the no results page. Maybe there actually were no results for that topic combination and that one search request somehow got through, but it seems unlikely - more likely, there is some bug in the logic updating the card after the filter is closed, triggered when the filter didn't make any search. (I seem to vaguely recall @kostajh looking into this at some point.)

Perhaps we could just not show the icon at all and try to use same/similar temporary error message No suggested articles available right now F34574077

That would work too, although like with the error card, I think we might want to make clearer that this is a transient error.

Replaced the animated gif with a video so it's a little easier to navigate.

However, is it the case that the user would have to refresh in order for the article suggestions to appear even after the error is fixed, or will it happen automatically? If the former, then maybe we could also add a refresh action to the message, maybe something like this:

image.png (902×704 px, 51 KB)

They would have to refresh, or do something equivalent like changing filter settings.

OK yes, in that case I would suggest amending the message to call attention to a need for refreshing. @MMiller_WMF - does the proposed amended error message with "refresh" action sound OK to you:

image.png (922×648 px, 49 KB)

  1. when users have topics selected this should be reflected in the UI with "X topics selected", and

True, that was also broken. Maybe something related to the search errors caused a JS error? Otherwise, I don't see a connection.

  1. the specific illustration and message should prompt the user to change their filters. I.e., it should look like the following:

F34574071
We don't have that kind of message currently, so that would be a feature request. The other bug is around 0:48 in the video: opening and closing (with no action) the topic filter replaces the error page with the no results page. Maybe there actually were no results for that topic combination and that one search request somehow got through, but it seems unlikely - more likely, there is some bug in the logic updating the card after the filter is closed, triggered when the filter didn't make any search. (I seem to vaguely recall @kostajh looking into this at some point.)

We do have that message, though my mock shows slightly different copy. Here's what it looks like in production when you set the filters so that there are no results:

image.png (1×1 px, 98 KB)

I've filed a bug report for the display of these messages being incorrect at T287944, but haven't been able to reproduce the two other bugs in @MMiller_WMF's video – no number of selected topics displayed, and incorrect error message. Could @Etonkovidova perhaps take a look to confirm that this is happening?

Perhaps we could just not show the icon at all and try to use same/similar temporary error message No suggested articles available right now

image.png (214×622 px, 15 KB)

That would work too, although like with the error card, I think we might want to make clearer that this is a transient error.

Yes, something like the revised message header in F34574075 "Temporary delay in finding article suggestions" or a better version of that.

This issue still exists, but only appears on search errors. We're not going to prioritize it now, but we may in the future.

@Tgr is going to update the task description and title.

Tgr renamed this task from No suggestions found on enwiki to Newcomer tasks search error card has UX issues.Aug 12 2021, 5:46 AM
Tgr updated the task description. (Show Details)